<template lang="pug">
div
  q-dialog(v-model="playvideo")
    q-card(style="width: 700px; max-width: 90vw")
      q-video(
        v-if="currentvideo.youtube",
        :src="'https://www.youtube.com/embed/' + currentvideo.youtube",
        :ratio="16 / 9"
      )
      q-video(
        v-if="!currentvideo.youtube",
        :src="getNonTubeLink(currentvideo)",
        :ratio="16 / 9"
      ) 
      q-btn.full-width(
        color="grey-5",
        dense,
        flat,
        type="a",
        :href="getNonTubeLink(currentvideo)",
        target="_blank"
      ) {{ $t('no_youtube') }}

  q-dialog(v-model="playimg")
    q-card(style="width: 700px; max-width: 90vw")
      q-img(contain, :src="getS3Link(currentimg.src)", :ratio="16 / 9")

  .q-pa-lg.flex.flex-center

  q-infinite-scroll(scroll-target="body", ref="scroller", @load="onLoad")
    template(v-slot:loading)
      .row.justify-center.q-my-md
        q-spinner-dots(color="primary", size="40px")

    .text-center.q-my-lg(v-if="!loading && !submissions.length") {{ $t('nosubmissions') }}

    .q-my-md(v-for="submission of submissions", :key="submission.id")
      q-card.col-12.overflow-hidden(bordered, flat)
        .lt-sm
          q-img.full-width.cursor-pointer(
            v-if="getMediaField('image', submission.media)",
            :ratio="8 / 3",
            @click="select(submission)",
            :src="getS3Link(getMediaField('image', submission.media).src)",
            cover
          )
          q-skeleton.full-width(
            square,
            v-if="!getMediaField('image', submission.media)",
            style="height: 130px"
          )
        q-card-section(horizontal)
          .gt-xs
            q-img.full-height.cursor-pointer(
              style="width: 280px",
              v-if="getMediaField('image', submission.media)",
              :ratio="16 / 9",
              @click="select(submission)",
              :src="getS3Link(getMediaField('image', submission.media).src)",
              cover
            )
            q-skeleton.full-height(
              square,
              v-if="!getMediaField('image', submission.media)",
              style="width: 120px"
            )
          q-card-section.full-width
            .row.justify-between
              .col-xs-12
                .text-h6
                  q-btn.float-right(
                    round,
                    flat,
                    :icon="currentselection == submission.id ? 'keyboard_arrow_up' : 'keyboard_arrow_down'",
                    @click="select(submission)"
                  )
                    q-tooltip {{ $t('show_assets') }}
                  q-btn.float-right(
                    v-if="getYoutube(submission)",
                    round,
                    flat,
                    target="_blank",
                    :icon="fabYouTube",
                    type="a",
                    :href="'https://www.youtube.com/v/' + getYoutube(submission).youtube",
                    color="red"
                  )
                    q-tooltip {{ $t('view_on_youtube') }}
                  div.float-right.text-grey-6 {{getActualTime(submission.createdAt)}}
                  //- q-btn.float-right(
                  //-   round,
                  //-   flat,
                  //-   icon="cloud_download",
                  //-   :disable="submissionDownloadInProgress",
                  //-   @click="downloadAll(submission)"
                  //- )
                  //-   q-tooltip {{ $t('download_assets') }}
                  span {{ getTitle(submission) }}
            .row
              .col.text-right
                q-chip.text-uppercase(
                  dense,
                  color="secondary",
                  outline,
                  v-for="tag of submission.tags",
                  :key="tag"
                ) {{ $t('tags.' + tag) }}
                q-chip.text-uppercase(dense, color="secondary", outline) {{ codeToLang(submission.language).englishName }}
                q-chip.text-uppercase(dense, color="secondary", outline) {{ codeToRegion(submission.region) }}
                div
                  q-chip(
                    v-if="submission.submitted_by && submission.submitted_by.user_name"
                  )
                    q-avatar.bg-grey-5
                      q-img(
                        :src="submission.submitted_by.photo_url",
                        v-if="submission.submitted_by.photo_url"
                      )
                      q-icon(name="person")
                    span {{ submission.submitted_by.user_name }}
                  q-chip(v-for="team in submission.team", :key="team.name")
                    q-avatar.bg-grey-5
                      q-icon(name="person")
                    span {{ team.name }}
        q-slide-transition
          q-card-section.border-top(v-show="currentselection==submission.id")
            q-scroll-area(horizontal, style="height: 245px")
              .row.no-wrap
                Caption(
                  :submission="submission",
                  :lang="langswitch",
                  :metadata="metadata",
                  v-on:langswitch="switchlang",
                  :socialMedia="socialMedia"
                )

                q-card.column.on-left(
                  v-for="media of sortMedia(submission)",
                  :key="media.id",
                  v-if="canDisplay(media)",
                  bordered,
                  flat
                )
                  q-img.cursor-pointer(
                    :ratio="16 / 9",
                    v-if="media.type == 'image'",
                    :src="getS3Link(media.src)",
                    style="width: 275px",
                    contain,
                    @click="currentimg = media; playimg = true"
                  )
                  q-img.cursor-pointer(
                    :ratio="16 / 9",
                    v-if="media.type == 'hd_video'",
                    :src="getThumbnail(submission)",
                    style="width: 267px",
                    @click="currentvideo = media; playvideo = true",
                    ripple
                  )
                    q-icon.absolute-center(
                      name="play_arrow",
                      color="white",
                      size="lg"
                    )
                  q-img.cursor-pointer(
                    :ratio="1",
                    v-if="media.type == 'square_video'",
                    :src="getThumbnail(submission)",
                    style="width: 150px",
                    @click="currentvideo = media; playvideo = true"
                  )
                    q-icon.absolute-center(
                      name="play_arrow",
                      color="white",
                      size="lg"
                    )
                  q-card-section.col.scroll(
                    :class="{ 'text-grey-5': !hasLang(media) }",
                    style="min-width: 300px; max-width: 300px; max-height: 150px",
                    v-if="media.type == 'social'"
                  ) {{ getCurrentLang(media) }}

                  q-card-section.q-pa-xs
                    q-icon(
                      :name="getTypeIcon(media.type)",
                      color="secondary",
                      size="sm"
                    )
                    .float-right
                      q-chip.q-ml-xs(
                        @click="langswitch = lang.targetLang || lang.srcLang",
                        dense,
                        clickable,
                        :disable="!canUseLang(lang)",
                        color="secondary",
                        outline,
                        v-for="lang of media.langs",
                        :key="lang.id",
                        :color="lang.targetLang == langswitch || (langswitch == lang.srcLang && lang.original) ? 'secondary' : 'grey'"
                      )
                        span {{ lang.targetLang || lang.srcLang }}
                        span(v-if="lang.original") *
                  q-separator
                  q-card-actions.col-auto(align="between")
                    q-btn(
                      flat,
                      icon="download",
                      @click="download(media)",
                      v-if="canDownload(media)"
                    )
                    q-btn(
                      flat,
                      icon="copy_all",
                      @click="copy(media)",
                      v-if="canCopy(media)"
                    )
                    q-btn(
                      flat,
                      icon="link",
                      v-if="media.src",
                      @click="copyLink(media.src)"
                    )
      .text-right.text-overline.text-grey-5 {{ getRelativeTime(submission.createdAt) }}
</template>

<script>
// import size from "lodash/size";
import includes from "lodash/includes";
import map from "lodash/map";
import last from "lodash/last";
import find from "lodash/find";
import sortBy from "lodash/sortBy";
import { DateTime } from "luxon";
import { copyToClipboard, openURL } from "quasar";
import { db } from "../db";
import langmap from "langmap";
import axios from "axios";
import { poll } from "../util/poll";
import { ifrcList as regions } from "ifrc-list";
import Caption from "@/components/Caption";
import { fabYoutube } from "@quasar/extras/fontawesome-v5";

export default {
  name: "Submissions",
  components: { Caption },
  created() {
    this.fabYouTube = fabYoutube;
  },
  data: () => ({
    playvideo: false,
    submissions: [],
    playimg: false,
    currentvideo: {},
    currentimg: {},
    langswitch: "en",
    loading: true,
    submissionDownloadInProgress: false,
    currentselection: "",
    rawcaptions: {},
  }),
  methods: {
    getYoutube(submission) {
      let yt = find(submission.media, { type: "hd_video" });
      return yt.youtube ? yt : false;
    },
    switchlang(lang) {
      // console.log(lang);
      this.langswitch = lang;
    },
    getNonTubeLink(media) {
      // console.log(media);
      if (!media) return "";
      if (!media.src) return "";
      return `${this.metadata.cloudfronturl}${media.src
        .replace("s3://", "")
        .replace(this.metadata.bucketname, "")
        .replace("hd_video", "hd_video_transcoded")}`;
    },
    sortMedia(submission) {
      if (submission.media) {
        return sortBy(submission.media, (f) => {
          if (f) {
            switch (f.type) {
              case "image":
                return 1;
              default:
                return -1;
            }
          }
        });
      }
    },
    getThumbnail(submission) {
      let raw = find(submission.media, { type: "raw" });
      return `${this.getS3Link(raw.src).replace(".mp4", "")}.0000002.jpg`;
    },
    codeToRegion(code) {
      let country = find(regions, { code: code });
      return `${country.flag} ${country.name}`;
    },
    codeToRegionNoFlag(code) {
      let country = find(regions, { code: code });
      return `${country.name}`;
    },
    codeToLang(code) {
      return langmap[code];
    },
    async onLoad(index, done) {
      await this.getSubmissions(done);
    },
    async getSubmissions(done) {
      this.loading = true;
      try {
        let ref = db.collection("submissions");
        ref = ref.where("status", "==", "edited");

        ref = ref.where("phase", "==", this.terms.phase);

        if (this.terms.lang) {
          ref = ref.where("language", "==", this.terms.lang);
        }

        if (this.terms.region) {
          ref = ref.where("region", "==", this.terms.region);
        }

        // for each
        if (this.terms.tags) {
          let tt = [];
          for (const [k, v] of Object.entries(this.terms.tags)) {
            // console.log(k);
            if (v) tt.push(k);
          }
          let tags = tt;
          // console.log(tags);
          if (tags.length) {
            ref = ref.where("tags", "array-contains-any", tags);
          }
        }

        // if (this.terms.text) {
        //   ref = ref.where("region", "==", this.terms.region);
        // }

        ref = ref.orderBy("createdAt", "desc");

        if (this.submissions.length > 0) {
          let lastl = last(this.submissions);
          // let lastref = await db.collection("submissions").doc(last.id).get();
          ref = ref.startAfter(lastl._doc);
        }

        ref = ref.limit(20);

        await this.$bind("tmpsubs", ref, {
          maxRefDepth: 3,
        });

        this.tmpsubs.forEach((doc) => {
          // console.log(doc);
          this.submissions.push(doc);
        });

        let length = this.tmpsubs.length;

        this.$unbind("tmpsubs", true);

        // Prevent from receiving updates automatically

        if (done) done(length == 0);
        else this.$refs.scroller.stop();
      } catch (e) {
        console.log(e);
        this.showError(e);
      }
      this.loading = false;
    },
    async copyLink(src) {
      try {
        let url = `${this.metadata.cloudfronturl}${src
          .replace("s3://", "")
          .replace(this.metadata.bucketname, "")}`;
        await copyToClipboard(url);
        this.$q.notify({
          // position: "bottom",
          // title: this.$t("success"),
          type: "positive",
          // icon: 'check_circle_outline'
          // message: this.$t("copiedtoclipboard"),
        });
        // console.log("copied");
      } catch (e) {
        console.log("problem copying", e);
        this.showError(e);
      }
    },
    select(submission) {
      // console.log(submission);
      if (this.currentselection == submission.id) this.currentselection = "";
      else this.currentselection = submission.id;
    },
    showDownloadInProgressNotif() {
      return this.$q.notify({
        type: "ongoing",
        message: this.$t("download_processing"),
        position: "bottom-right",
      });
    },
    requestSubmissionZip(isPoll, submissionId) {
      return axios.request({
        url: `https://ahm9x0vrfl.execute-api.ap-southeast-2.amazonaws.com/default/YouthInnovationSubmissionZip`,
        method: "POST",
        headers: {
          "Content-Type": "text/plain",
        },
        data: JSON.stringify({
          key: "DEV_KEY",
          submissionId: submissionId,
          isPoll: isPoll,
        }),
      });
    },
    async downloadAll(submission) {
      this.submissionDownloadInProgress = true;

      const dismiss = this.showDownloadInProgressNotif();
      // This request is likely to fail, because the process
      // of creating the zip takes longer than the API Gateway
      // will stay open. (We still need to make the request,
      // to initiate creating the zip though)
      this.requestSubmissionZip(false, submission.id).catch(() =>
        console.log("processing download")
      );

      await new Promise((resolve) => setTimeout(resolve, 2000)); // Wait 2 seconds before beginning polling

      const dataOrError = await poll({
        fn: () =>
          this.requestSubmissionZip(true, submission.id).catch((e) => ({
            error: e.body.error,
          })),
        validate: (result) => result.error || (result.data && result.data.path), // Short circuit on errors
        interval: 5 * 1000, // Poll every 5 seconds,
        maxAttempts: 96,
      }).catch(() => {
        return { error: "You download failed, please try again" };
      });

      this.submissionDownloadInProgress = false;
      dismiss();

      if (dataOrError.error) {
        this.$q.notify({
          type: "negative",
          message: dataOrError.error,
        });
      }

      if (dataOrError.data) {
        const src = dataOrError.data.path;

        openURL(
          `${this.metadata.cloudfronturl}/${src.replace(
            "s3://youth-innovation/",
            ""
          )}`
        );
      }
    },
    canUseLang(lang) {
      // console.log(lang);
      return lang.original || lang.status == "finalised";
    },
    hasLang(media) {
      let langs = map(media.langs, (m) => {
        if (m.targetLang && m.status == "finalised") return m.targetLang;
        else if (m.srcLang && m.original) return m.srcLang;
        else return null;
      });

      return includes(langs, this.langswitch);
    },
    download(media) {
      try {
        switch (media.type) {
          case "image":
          case "longform":
          case "hd_video":
          case "square_video":
            openURL(this.getS3Link(media.src));
            break;
        }
      } catch (e) {
        this.showError(e);
      }
    },
    async copy(media) {
      try {
        await copyToClipboard(this.getCurrentLang(media));
        this.$q.notify({
          type: "positive",
        });
      } catch (e) {
        console.log("problem copying", e);
        this.showError(e);
      }
    },
    canDownload(media) {
      return includes(
        ["image", "hd_video", "square_video", "caption"],
        media.type
      );
    },
    canCopy(media) {
      return includes(["social", "caption", "title"], media.type);
    },
    canDisplay(media) {
      if (media) {
        return includes(
          ["image", "social", "hd_video", "square_video"],
          media.type
        );
      }
    },
    getTypeIcon(type) {
      switch (type) {
        case "hd_video":
          return "hd";
        case "image":
          return "photo";
        case "square_video":
          return "crop_square";
        case "caption":
          return "format_align_left";
        case "social":
          return "short_text";
        default:
          return "";
      }
    },
    getRelativeTime(time) {
      return DateTime.fromSeconds(parseInt(time.seconds)).toRelative();
    },
    getActualTime(time) {
      return DateTime.fromSeconds(parseInt(time.seconds)).toLocaleString(
        DateTime.DATETIME_FULL
      );
    },
    getMediaField(type, media) {
      let lf = find(media, { type: type });
      // console.log(type);
      if (!lf) return null;
      return lf;
    },
    getCurrentLang(media) {
      try {
        if (!media || !media.langs) return "";

        // console.log(media.langs);

        let target = find(media.langs, { targetLang: this.langswitch });
        // console.log(target);
        if (
          typeof target != "undefined" &&
          ((target.status && target.status == "finalised") || !target.status)
        )
          return target.targetText;
        else if (media.langs.length)
          return find(media.langs, { original: true }).srcText;
        else return "en";
      } catch {
        return "en";
      }
    },
    getS3Link(src) {
      if (!src) return "";
      let url = `${this.metadata.cloudfronturl}${src
        .replace("s3://", "")
        .replace(this.metadata.bucketname, "")}`;
      return url;
    },
    getTitle(submission) {
      try {
        let userName = "";
        if (submission.submitted_by && submission.submitted_by.user_name)
          userName = submission.submitted_by.user_name;
        else userName = "Reporter";
        return this.socialMedia["youtube_title_" + submission.phase].en
          .replace("{0}", userName)
          .replace("{1}", this.codeToRegionNoFlag(submission.region));
      } catch {
        return this.socialMedia["youtube_title_" + submission.phase].en.replace(
          "{0}",
          ""
        );
      }
    },
  },
  watch: {
    terms: {
      deep: true,
      async handler() {
        this.submissions = [];
        this.$refs.scroller.reset();
        this.$refs.scroller.resume();
        this.$refs.scroller.trigger();
      },
    },
  },
  props: ["terms", "metadata", "socialMedia"],
};
</script>

<style scoped>
.border-top {
  border-top: solid #eee 1px;
}
</style>
